<?php

class ilPlagScanAssignmentConfigData
{
    protected $valid_start_check_values = array('manual','automatic','immediate');
    protected $valid_share_setting_values = array('never','deadline', 'always');
    protected $valid_share_type_values = array('percentage_only', 'percentage_link');

    protected $exercise_obj_id;
    protected $assignment_id;

    protected $activation;
    protected $start_check;
    protected $share_setting;
    protected $share_type;

    public function __construct(
        int $exercise_obj_id,
        int $assignment_id,
        bool $activation,
        string $start_check,
        string $share_setting,
        string $share_type)
    {
        $this->exercise_obj_id = $exercise_obj_id;
        $this->assignment_id = $assignment_id;

        $this->activation = $activation;
        if($this->activation)
        {
            if(in_array($start_check, $this->valid_start_check_values)) {
                $this->start_check = $start_check;
            } else {
                throw new InvalidArgumentException('Not a valid start_check: ' . $start_check);
            }

            if(in_array($share_setting, $this->valid_share_setting_values)) {
                $this->share_setting = $share_setting;
            } else {
                throw new InvalidArgumentException('Not a valid share_setting: ' . $share_setting);
            }

            if(in_array($share_type, $this->valid_share_type_values)) {
                $this->share_type = $share_type;
            } else{
                throw new InvalidArgumentException('Not a valid share_type: ' . $share_type);
            }
        } else {
            $this->start_check = 'none';
            $this->share_setting = 'none';
            $this->share_type = 'none';
        }
    }

    /**
     * @return int
     */
    public function getExerciseObjId() : int
    {
        return $this->exercise_obj_id;
    }

    /**
     * @return int
     */
    public function getAssignmentId() : int
    {
        return $this->assignment_id;
    }

    /**
     * @return bool
     */
    public function getActivation() : bool
    {
        return $this->activation;
    }

    /**
     * @return string
     */
    public function getStartCheck() : string
    {
        return $this->start_check;
    }

    /**
     * @return string
     */
    public function getShareSetting() : string
    {
        return $this->share_setting;
    }

    /**
     * @return string
     */
    public function getShareType() : string
    {
        return $this->share_type;
    }
}