<?php

class ilPlagScanDocument
{
    protected $id;
    protected $assignment_exc_obj;
    protected $assignment_id;
    protected $user_id;
    protected $user_non_consent;
    protected $submission_ilias_id;
    protected $plagscan_id;
    protected $plagscan_status;
    protected $share_link;

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param mixed $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getAssignmentExcObj()
    {
        return $this->assignment_exc_obj;
    }

    /**
     * @param mixed $assignment_exc_obj
     */
    public function setAssignmentExcObj($assignment_exc_obj)
    {
        $this->assignment_exc_obj = $assignment_exc_obj;
    }

    /**
     * @return mixed
     */
    public function getAssignmentId()
    {
        return $this->assignment_id;
    }

    /**
     * @param mixed $assignment_id
     */
    public function setAssignmentId($assignment_id)
    {
        $this->assignment_id = $assignment_id;
    }

    /**
     * @return mixed
     */
    public function getUserId()
    {
        return $this->user_id;
    }

    /**
     * @param mixed $user_id
     */
    public function setUserId($user_id)
    {
        $this->user_id = $user_id;
    }

    /**
     * @return mixed
     */
    public function getUserNonConsent()
    {
        return $this->user_non_consent;
    }

    /**
     * @param mixed $user_non_consent
     */
    public function setUserNonConsent($user_non_consent)
    {
        $this->user_non_consent = $user_non_consent;
    }

    /**
     * @return mixed
     */
    public function getSubmissionIliasId()
    {
        return $this->submission_ilias_id;
    }

    /**
     * @param mixed $submission_ilias_id
     */
    public function setSubmissionIliasId($submission_ilias_id)
    {
        $this->submission_ilias_id = $submission_ilias_id;
    }

    /**
     * @return mixed
     */
    public function getPlagscanId()
    {
        return $this->plagscan_id;
    }

    /**
     * @param mixed $plagscan_id
     */
    public function setPlagscanId($plagscan_id)
    {
        $this->plagscan_id = $plagscan_id;
    }

    /**
     * @return mixed
     */
    public function getPlagscanStatus()
    {
        return $this->plagscan_status;
    }

    /**
     * @param mixed $plagscan_status
     */
    public function setPlagscanStatus($plagscan_status)
    {
        $this->plagscan_status = $plagscan_status;
    }

    /**
     * @return mixed
     */
    public function getShareLink()
    {
        return $this->share_link;
    }

    /**
     * @param mixed $share_link
     */
    public function setShareLink($share_link)
    {
        $this->share_link = $share_link;
    }

    public function getByUserAssignment($user_id, $assignment_id)
    {
        global $ilDB;
        $result = $ilDB->query('SELECT * FROM psx_submissions WHERE assignment_id = ' . $ilDB->quote($assignment_id, 'integer')
        . ' AND user_id = ' . $ilDB->quote($user_id, 'integer'));

        if($ilDB->numRows($result) > 0 ) {
            $row = $ilDB->fetchAssoc($result);

            $this->id = $row['id'];
            $this->assignment_exc_obj = $row['assignment_exc_obj'];
            $this->assignment_id = $row['assignment_id'];
            $this->user_id = $row['user_id'];
            $this->user_non_consent = $row['user_non_consent'];
            $this->submission_ilias_id = $row['submission_ilias_id'];
            $this->plagscan_id = $row['plagscan_id'];
            $this->plagscan_status = $row['plagscan_status'];
            $this->share_link = $row['share_link'];
        } else {
            $this->assignment_id = $assignment_id;
            $this->user_id = $user_id;
        }

        return $this;
    }

    public function getByPlagScanId($doc_id)
    {
        global $ilDB;
        $result = $ilDB->query('SELECT * FROM psx_submissions WHERE plagscan_id = ' . $ilDB->quote($doc_id, 'integer'));

        $row = $ilDB->fetchAssoc($result);

        $this->id = $row['id'];
        $this->assignment_exc_obj = $row['assignment_exc_obj'];
        $this->assignment_id = $row['assignment_id'];
        $this->user_id = $row['user_id'];
        $this->user_non_consent = $row['user_non_consent'];
        $this->submission_ilias_id = $row['submission_ilias_id'];
        $this->plagscan_id = $row['plagscan_id'];
        $this->plagscan_status = $row['plagscan_status'];
        $this->share_link = $row['share_link'];

        return $this;
    }

    public function store()
    {
        global $ilDB;

        if($this->id != null)
        {
            $ilDB->manipulate('DELETE FROM psx_submissions WHERE id = ' . $ilDB->quote($this->id, 'integer'));
        }
        $this->id = $ilDB->nextId('psx_submissions');
        $ilDB->insert(
            'psx_submissions',
            array(
                'id'    => array('int', $this->id),
                'assignment_exc_obj'    => array('int', $this->assignment_exc_obj),
                'assignment_id'    => array('int', $this->assignment_id),
                'user_id'    => array('int', $this->user_id),
                'user_non_consent'    => array('int', $this->user_non_consent),
                'submission_ilias_id'    => array('int', $this->submission_ilias_id),
                'plagscan_id'    => array('int', $this->plagscan_id),
                'plagscan_status'    => array('int', $this->plagscan_status),
                'share_link'    => array('int', $this->share_link)
            )
        );
    }
}